import{S as wn,i as bn,s as xn,e as n,k as p,w as _,t as l,M as $n,c as s,d as t,m as u,a,x as g,h as i,b as f,$ as qn,G as o,g as m,y as v,L as Tn,q as w,o as b,B as x,v as Nn}from"../../../chunks/vendor-hf-doc-builder.js";import{I as he}from"../../../chunks/IconCopyLink-hf-doc-builder.js";import{C as ce}from"../../../chunks/CodeBlock-hf-doc-builder.js";function yn(ko){let N,Ie,y,S,_e,C,qt,ge,Tt,Ce,A,Nt,ne,yt,Ot,Qe,O,M,ve,Q,kt,we,Et,We,d,jt,be,Xt,St,xe,At,Mt,$e,Pt,Rt,qe,Ft,Ht,Ue,P,Dt,Te,Lt,zt,Be,W,Ve,k,R,Ne,U,It,ye,Ct,Ge,h,Qt,se,Wt,Ut,Oe,Bt,Vt,ae,Gt,Yt,Ye,B,Je,E,F,ke,V,Jt,Ee,Kt,Ke,c,Zt,G,eo,to,je,oo,no,Y,so,ao,Ze,J,et,j,H,Xe,K,ro,Se,lo,tt,re,io,ot,$,Ae,mo,po,Me,uo,fo,Pe,ho,nt,le,co,st,Z,at,X,D,Re,ee,_o,Fe,go,rt,ie,vo,lt,q,He,wo,bo,De,xo,$o,Le,qo,it,me,To,mt,te,pt,L,No,ze,yo,Oo,ut,oe,ft,pe,ue,Eo,dt;return C=new he({}),Q=new he({}),W=new ce({props:{code:`from transformers import AutoTokenizer, pipeline
-from transformers import AutoModelForQuestionAnswering
+from optimum.onnxruntime import ORTModelForQuestionAnswering

-model = AutoModelForQuestionAnswering.from_pretrained("deepset/roberta-base-squad2") # PyTorch checkpoint
+model = ORTModelForQuestionAnswering.from_pretrained("optimum/roberta-base-squad2") # ONNX checkpoint
tokenizer = AutoTokenizer.from_pretrained("deepset/roberta-base-squad2")

onnx_qa = pipeline("question-answering",model=model,tokenizer=tokenizer)

question = "What's my name?"
context = "My name is Philipp and I live in Nuremberg."
pred = onnx_qa(question, context)`,highlighted:`from transformers import AutoTokenizer, pipeline
<span class="hljs-deletion">-from transformers import AutoModelForQuestionAnswering</span>
<span class="hljs-addition">+from optimum.onnxruntime import ORTModelForQuestionAnswering</span>

<span class="hljs-deletion">-model = AutoModelForQuestionAnswering.from_pretrained(&quot;deepset/roberta-base-squad2&quot;) # PyTorch checkpoint</span>
<span class="hljs-addition">+model = ORTModelForQuestionAnswering.from_pretrained(&quot;optimum/roberta-base-squad2&quot;) # ONNX checkpoint</span>
tokenizer = AutoTokenizer.from_pretrained(&quot;deepset/roberta-base-squad2&quot;)

onnx_qa = pipeline(&quot;question-answering&quot;,model=model,tokenizer=tokenizer)

question = &quot;What&#x27;s my name?&quot;
context = &quot;My name is Philipp and I live in Nuremberg.&quot;
pred = onnx_qa(question, context)`}}),U=new he({}),B=new ce({props:{code:`from optimum.onnxruntime import ORTModelForSequenceClassification

# Load the model from the hub and export it to the ONNX format
model = ORTModelForSequenceClassification.from_pretrained(
    "distilbert-base-uncased-finetuned-sst-2-english", from_transformers=True
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTModelForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load the model from the hub and export it to the ONNX format</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForSequenceClassification.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;distilbert-base-uncased-finetuned-sst-2-english&quot;</span>, from_transformers=<span class="hljs-literal">True</span>
<span class="hljs-meta">... </span>)`}}),V=new he({}),J=new ce({props:{code:`from optimum.onnxruntime import ORTModelForSequenceClassification

# Load the model from the hub and export it to the ONNX format
model = ORTModelForSequenceClassification.from_pretrained(
    "distilbert-base-uncased-finetuned-sst-2-english", from_transformers=True
)

# Save the converted model
model.save_pretrained("a_local_path_for_convert_onnx_model")

model.push_to_hub(
  "a_local_path_for_convert_onnx_model", repository_id="my-onnx-repo", use_auth_token=True
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTModelForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load the model from the hub and export it to the ONNX format</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForSequenceClassification.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;distilbert-base-uncased-finetuned-sst-2-english&quot;</span>, from_transformers=<span class="hljs-literal">True</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Save the converted model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.save_pretrained(<span class="hljs-string">&quot;a_local_path_for_convert_onnx_model&quot;</span>)

<span class="hljs-comment"># Push the onnx model to HF Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.push_to_hub(
<span class="hljs-meta">... </span>  <span class="hljs-string">&quot;a_local_path_for_convert_onnx_model&quot;</span>, repository_id=<span class="hljs-string">&quot;my-onnx-repo&quot;</span>, use_auth_token=<span class="hljs-literal">True</span>
<span class="hljs-meta">... </span>)`}}),K=new he({}),Z=new ce({props:{code:`from transformers import AutoTokenizer, pipeline
from optimum.onnxruntime import ORTModelForSeq2SeqLM

model_name = "t5-small"
model = ORTModelForSeq2SeqLM.from_pretrained(model_name, from_transformers=True)
tokenizer = AutoTokenizer.from_pretrained(model_name)

onnx_translation = pipeline("translation_en_to_fr", model=model, tokenizer=tokenizer)
text = "He never went out without a book under his arm, and he often came back with two."
result = onnx_translation(text)
# [{'translation_text': "Il n'est jamais sorti sans un livre sous son bras, et il est souvent revenu avec deux."}]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, pipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTModelForSeq2SeqLM

<span class="hljs-comment"># Load the model from the hub and export it to the ONNX format</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model_name = <span class="hljs-string">&quot;t5-small&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForSeq2SeqLM.from_pretrained(model_name, from_transformers=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(model_name)

<span class="hljs-comment"># Create a pipeline</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_translation = pipeline(<span class="hljs-string">&quot;translation_en_to_fr&quot;</span>, model=model, tokenizer=tokenizer)
<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;He never went out without a book under his arm, and he often came back with two.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>result = onnx_translation(text)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># [{&#x27;translation_text&#x27;: &quot;Il n&#x27;est jamais sorti sans un livre sous son bras, et il est souvent revenu avec deux.&quot;}]</span>`}}),ee=new he({}),te=new ce({props:{code:`from optimum.onnxruntime import ORTStableDiffusionPipeline

model_id = "runwayml/stable-diffusion-v1-5"
stable_diffusion = ORTStableDiffusionPipeline.from_pretrained(model_id, revision="onnx")
prompt = "sailing ship in storm by Leonardo da Vinci"
image = stable_diffusion(prompt).images[0]`,highlighted:`<span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTStableDiffusionPipeline

model_id = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
stable_diffusion = ORTStableDiffusionPipeline.from_pretrained(model_id, revision=<span class="hljs-string">&quot;onnx&quot;</span>)
prompt = <span class="hljs-string">&quot;sailing ship in storm by Leonardo da Vinci&quot;</span>
image = stable_diffusion(prompt).images[<span class="hljs-number">0</span>]`}}),oe=new ce({props:{code:`stable_diffusion = ORTStableDiffusionPipeline.from_pretrained(model_id, export=True)

# Don't forget to save the ONNX model
save_directory = "a_local_path"
stable_diffusion.save_pretrained(save_directory)`,highlighted:`stable_diffusion = ORTStableDiffusionPipeline.from_pretrained(model_id, export=<span class="hljs-literal">True</span>)

<span class="hljs-comment"># Don&#x27;t forget to save the ONNX model</span>
save_directory = <span class="hljs-string">&quot;a_local_path&quot;</span>
stable_diffusion.save_pretrained(save_directory)`}}),{c(){N=n("meta"),Ie=p(),y=n("h1"),S=n("a"),_e=n("span"),_(C.$$.fragment),qt=p(),ge=n("span"),Tt=l("Optimum Inference with ONNX Runtime"),Ce=p(),A=n("p"),Nt=l(`Optimum is a utility package for building and running inference with accelerated runtime like ONNX Runtime.
Optimum can be used to load optimized models from the `),ne=n("a"),yt=l("Hugging Face Hub"),Ot=l(` and create pipelines
to run accelerated inference without rewriting your APIs.`),Qe=p(),O=n("h2"),M=n("a"),ve=n("span"),_(Q.$$.fragment),kt=p(),we=n("span"),Et=l("Switching from Transformers to Optimum"),We=p(),d=n("p"),jt=l("The "),be=n("code"),Xt=l("optimum.onnxruntime.ORTModelForXXX"),St=l(` model classes are API compatible with Hugging Face Transformers models. This
means you can just replace your `),xe=n("code"),At=l("AutoModelForXXX"),Mt=l(" class with the corresponding "),$e=n("code"),Pt=l("ORTModelForXXX"),Rt=l(" class in "),qe=n("code"),Ft=l("optimum.onnxruntime"),Ht=l("."),Ue=p(),P=n("p"),Dt=l("You do not need to adapt your code to get it to work with "),Te=n("code"),Lt=l("ORTModelForXXX"),zt=l(" classes:"),Be=p(),_(W.$$.fragment),Ve=p(),k=n("h3"),R=n("a"),Ne=n("span"),_(U.$$.fragment),It=p(),ye=n("span"),Ct=l("Loading a vanilla Transformers model"),Ge=p(),h=n("p"),Qt=l("Because the model you want to work with might not be already converted to ONNX,  "),se=n("a"),Wt=l("ORTModel"),Ut=l(`
includes a method to convert vanilla Transformers models to ONNX ones. Simply pass `),Oe=n("code"),Bt=l("from_transformers=True"),Vt=l(` to the
`),ae=n("a"),Gt=l("from_pretrained()"),Yt=l(" method, and your model will be loaded and converted to ONNX on-the-fly:"),Ye=p(),_(B.$$.fragment),Je=p(),E=n("h3"),F=n("a"),ke=n("span"),_(V.$$.fragment),Jt=p(),Ee=n("span"),Kt=l("Pushing ONNX models to the Hugging Face Hub"),Ke=p(),c=n("p"),Zt=l("It is also possible, just as with regular "),G=n("a"),eo=l("PreTrainedModel"),to=l("s, to push your "),je=n("code"),oo=l("ORTModelForXXX"),no=l(` to the
`),Y=n("a"),so=l("Hugging Face Model Hub"),ao=l(":"),Ze=p(),_(J.$$.fragment),et=p(),j=n("h2"),H=n("a"),Xe=n("span"),_(K.$$.fragment),ro=p(),Se=n("span"),lo=l("Export and inference of sequence-to-sequence models"),tt=p(),re=n("p"),io=l(`Sequence-to-sequence (Seq2Seq) models can also be used when running inference with ONNX Runtime. When Seq2Seq models
are exported to the ONNX format, they are decomposed into three parts that are later combined during inference:`),ot=p(),$=n("ul"),Ae=n("li"),mo=l("The encoder part of the model"),po=p(),Me=n("li"),uo=l("The decoder part of the model + the language modeling head"),fo=p(),Pe=n("li"),ho=l(`The same decoder part of the model + language modeling head but taking and using pre-computed key / values as inputs and
outputs. This makes inference faster.`),nt=p(),le=n("p"),co=l("Here is an example of how you can load a T5 model to the ONNX format and run inference for a translation task:"),st=p(),_(Z.$$.fragment),at=p(),X=n("h2"),D=n("a"),Re=n("span"),_(ee.$$.fragment),_o=p(),Fe=n("span"),go=l("Export and inference of Stable Diffusion models"),rt=p(),ie=n("p"),vo=l(`Stable Diffusion models can also be used when running inference with ONNX Runtime. When Stable Diffusion models
are exported to the ONNX format, they are split into three components that are later combined during inference:`),lt=p(),q=n("ul"),He=n("li"),wo=l("The text encoder"),bo=p(),De=n("li"),xo=l("The U-NET"),$o=p(),Le=n("li"),qo=l("The VAE decoder"),it=p(),me=n("p"),To=l("Here is an example of how you can load an ONNX Stable Diffusion model and run inference using ONNX Runtime:"),mt=p(),_(te.$$.fragment),pt=p(),L=n("p"),No=l("To load your PyTorch model and convert it to ONNX on-the-fly, you can set "),ze=n("code"),yo=l("export=True"),Oo=l("."),ut=p(),_(oe.$$.fragment),ft=p(),pe=n("p"),ue=n("img"),this.h()},l(e){const r=$n('[data-svelte="svelte-1phssyn"]',document.head);N=s(r,"META",{name:!0,content:!0}),r.forEach(t),Ie=u(e),y=s(e,"H1",{class:!0});var ht=a(y);S=s(ht,"A",{id:!0,class:!0,href:!0});var jo=a(S);_e=s(jo,"SPAN",{});var Xo=a(_e);g(C.$$.fragment,Xo),Xo.forEach(t),jo.forEach(t),qt=u(ht),ge=s(ht,"SPAN",{});var So=a(ge);Tt=i(So,"Optimum Inference with ONNX Runtime"),So.forEach(t),ht.forEach(t),Ce=u(e),A=s(e,"P",{});var ct=a(A);Nt=i(ct,`Optimum is a utility package for building and running inference with accelerated runtime like ONNX Runtime.
Optimum can be used to load optimized models from the `),ne=s(ct,"A",{href:!0});var Ao=a(ne);yt=i(Ao,"Hugging Face Hub"),Ao.forEach(t),Ot=i(ct,` and create pipelines
to run accelerated inference without rewriting your APIs.`),ct.forEach(t),Qe=u(e),O=s(e,"H2",{class:!0});var _t=a(O);M=s(_t,"A",{id:!0,class:!0,href:!0});var Mo=a(M);ve=s(Mo,"SPAN",{});var Po=a(ve);g(Q.$$.fragment,Po),Po.forEach(t),Mo.forEach(t),kt=u(_t),we=s(_t,"SPAN",{});var Ro=a(we);Et=i(Ro,"Switching from Transformers to Optimum"),Ro.forEach(t),_t.forEach(t),We=u(e),d=s(e,"P",{});var T=a(d);jt=i(T,"The "),be=s(T,"CODE",{});var Fo=a(be);Xt=i(Fo,"optimum.onnxruntime.ORTModelForXXX"),Fo.forEach(t),St=i(T,` model classes are API compatible with Hugging Face Transformers models. This
means you can just replace your `),xe=s(T,"CODE",{});var Ho=a(xe);At=i(Ho,"AutoModelForXXX"),Ho.forEach(t),Mt=i(T," class with the corresponding "),$e=s(T,"CODE",{});var Do=a($e);Pt=i(Do,"ORTModelForXXX"),Do.forEach(t),Rt=i(T," class in "),qe=s(T,"CODE",{});var Lo=a(qe);Ft=i(Lo,"optimum.onnxruntime"),Lo.forEach(t),Ht=i(T,"."),T.forEach(t),Ue=u(e),P=s(e,"P",{});var gt=a(P);Dt=i(gt,"You do not need to adapt your code to get it to work with "),Te=s(gt,"CODE",{});var zo=a(Te);Lt=i(zo,"ORTModelForXXX"),zo.forEach(t),zt=i(gt," classes:"),gt.forEach(t),Be=u(e),g(W.$$.fragment,e),Ve=u(e),k=s(e,"H3",{class:!0});var vt=a(k);R=s(vt,"A",{id:!0,class:!0,href:!0});var Io=a(R);Ne=s(Io,"SPAN",{});var Co=a(Ne);g(U.$$.fragment,Co),Co.forEach(t),Io.forEach(t),It=u(vt),ye=s(vt,"SPAN",{});var Qo=a(ye);Ct=i(Qo,"Loading a vanilla Transformers model"),Qo.forEach(t),vt.forEach(t),Ge=u(e),h=s(e,"P",{});var z=a(h);Qt=i(z,"Because the model you want to work with might not be already converted to ONNX,  "),se=s(z,"A",{href:!0});var Wo=a(se);Wt=i(Wo,"ORTModel"),Wo.forEach(t),Ut=i(z,`
includes a method to convert vanilla Transformers models to ONNX ones. Simply pass `),Oe=s(z,"CODE",{});var Uo=a(Oe);Bt=i(Uo,"from_transformers=True"),Uo.forEach(t),Vt=i(z,` to the
`),ae=s(z,"A",{href:!0});var Bo=a(ae);Gt=i(Bo,"from_pretrained()"),Bo.forEach(t),Yt=i(z," method, and your model will be loaded and converted to ONNX on-the-fly:"),z.forEach(t),Ye=u(e),g(B.$$.fragment,e),Je=u(e),E=s(e,"H3",{class:!0});var wt=a(E);F=s(wt,"A",{id:!0,class:!0,href:!0});var Vo=a(F);ke=s(Vo,"SPAN",{});var Go=a(ke);g(V.$$.fragment,Go),Go.forEach(t),Vo.forEach(t),Jt=u(wt),Ee=s(wt,"SPAN",{});var Yo=a(Ee);Kt=i(Yo,"Pushing ONNX models to the Hugging Face Hub"),Yo.forEach(t),wt.forEach(t),Ke=u(e),c=s(e,"P",{});var I=a(c);Zt=i(I,"It is also possible, just as with regular "),G=s(I,"A",{href:!0,rel:!0});var Jo=a(G);eo=i(Jo,"PreTrainedModel"),Jo.forEach(t),to=i(I,"s, to push your "),je=s(I,"CODE",{});var Ko=a(je);oo=i(Ko,"ORTModelForXXX"),Ko.forEach(t),no=i(I,` to the
`),Y=s(I,"A",{href:!0,rel:!0});var Zo=a(Y);so=i(Zo,"Hugging Face Model Hub"),Zo.forEach(t),ao=i(I,":"),I.forEach(t),Ze=u(e),g(J.$$.fragment,e),et=u(e),j=s(e,"H2",{class:!0});var bt=a(j);H=s(bt,"A",{id:!0,class:!0,href:!0});var en=a(H);Xe=s(en,"SPAN",{});var tn=a(Xe);g(K.$$.fragment,tn),tn.forEach(t),en.forEach(t),ro=u(bt),Se=s(bt,"SPAN",{});var on=a(Se);lo=i(on,"Export and inference of sequence-to-sequence models"),on.forEach(t),bt.forEach(t),tt=u(e),re=s(e,"P",{});var nn=a(re);io=i(nn,`Sequence-to-sequence (Seq2Seq) models can also be used when running inference with ONNX Runtime. When Seq2Seq models
are exported to the ONNX format, they are decomposed into three parts that are later combined during inference:`),nn.forEach(t),ot=u(e),$=s(e,"UL",{});var fe=a($);Ae=s(fe,"LI",{});var sn=a(Ae);mo=i(sn,"The encoder part of the model"),sn.forEach(t),po=u(fe),Me=s(fe,"LI",{});var an=a(Me);uo=i(an,"The decoder part of the model + the language modeling head"),an.forEach(t),fo=u(fe),Pe=s(fe,"LI",{});var rn=a(Pe);ho=i(rn,`The same decoder part of the model + language modeling head but taking and using pre-computed key / values as inputs and
outputs. This makes inference faster.`),rn.forEach(t),fe.forEach(t),nt=u(e),le=s(e,"P",{});var ln=a(le);co=i(ln,"Here is an example of how you can load a T5 model to the ONNX format and run inference for a translation task:"),ln.forEach(t),st=u(e),g(Z.$$.fragment,e),at=u(e),X=s(e,"H2",{class:!0});var xt=a(X);D=s(xt,"A",{id:!0,class:!0,href:!0});var mn=a(D);Re=s(mn,"SPAN",{});var pn=a(Re);g(ee.$$.fragment,pn),pn.forEach(t),mn.forEach(t),_o=u(xt),Fe=s(xt,"SPAN",{});var un=a(Fe);go=i(un,"Export and inference of Stable Diffusion models"),un.forEach(t),xt.forEach(t),rt=u(e),ie=s(e,"P",{});var fn=a(ie);vo=i(fn,`Stable Diffusion models can also be used when running inference with ONNX Runtime. When Stable Diffusion models
are exported to the ONNX format, they are split into three components that are later combined during inference:`),fn.forEach(t),lt=u(e),q=s(e,"UL",{});var de=a(q);He=s(de,"LI",{});var dn=a(He);wo=i(dn,"The text encoder"),dn.forEach(t),bo=u(de),De=s(de,"LI",{});var hn=a(De);xo=i(hn,"The U-NET"),hn.forEach(t),$o=u(de),Le=s(de,"LI",{});var cn=a(Le);qo=i(cn,"The VAE decoder"),cn.forEach(t),de.forEach(t),it=u(e),me=s(e,"P",{});var _n=a(me);To=i(_n,"Here is an example of how you can load an ONNX Stable Diffusion model and run inference using ONNX Runtime:"),_n.forEach(t),mt=u(e),g(te.$$.fragment,e),pt=u(e),L=s(e,"P",{});var $t=a(L);No=i($t,"To load your PyTorch model and convert it to ONNX on-the-fly, you can set "),ze=s($t,"CODE",{});var gn=a(ze);yo=i(gn,"export=True"),gn.forEach(t),Oo=i($t,"."),$t.forEach(t),ut=u(e),g(oe.$$.fragment,e),ft=u(e),pe=s(e,"P",{});var vn=a(pe);ue=s(vn,"IMG",{src:!0,alt:!0}),vn.forEach(t),this.h()},h(){f(N,"name","hf:doc:metadata"),f(N,"content",JSON.stringify(On)),f(S,"id","optimum-inference-with-onnx-runtime"),f(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(S,"href","#optimum-inference-with-onnx-runtime"),f(y,"class","relative group"),f(ne,"href","hf.co/models"),f(M,"id","switching-from-transformers-to-optimum"),f(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(M,"href","#switching-from-transformers-to-optimum"),f(O,"class","relative group"),f(R,"id","loading-a-vanilla-transformers-model"),f(R,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(R,"href","#loading-a-vanilla-transformers-model"),f(k,"class","relative group"),f(se,"href","/docs/optimum/main/en/onnxruntime/package_reference/modeling_ort#optimum.onnxruntime.ORTModel"),f(ae,"href","/docs/optimum/main/en/onnxruntime/package_reference/modeling_ort#optimum.onnxruntime.ORTModel.from_pretrained"),f(F,"id","pushing-onnx-models-to-the-hugging-face-hub"),f(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(F,"href","#pushing-onnx-models-to-the-hugging-face-hub"),f(E,"class","relative group"),f(G,"href","https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),f(G,"rel","nofollow"),f(Y,"href","https://hf.co/models"),f(Y,"rel","nofollow"),f(H,"id","export-and-inference-of-sequencetosequence-models"),f(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(H,"href","#export-and-inference-of-sequencetosequence-models"),f(j,"class","relative group"),f(D,"id","export-and-inference-of-stable-diffusion-models"),f(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(D,"href","#export-and-inference-of-stable-diffusion-models"),f(X,"class","relative group"),qn(ue.src,Eo="https://huggingface.co/datasets/optimum/documentation-images/resolve/main/onnxruntime/stable_diffusion_v1_5_ort_sail_boat.png")||f(ue,"src",Eo),f(ue,"alt","img")},m(e,r){o(document.head,N),m(e,Ie,r),m(e,y,r),o(y,S),o(S,_e),v(C,_e,null),o(y,qt),o(y,ge),o(ge,Tt),m(e,Ce,r),m(e,A,r),o(A,Nt),o(A,ne),o(ne,yt),o(A,Ot),m(e,Qe,r),m(e,O,r),o(O,M),o(M,ve),v(Q,ve,null),o(O,kt),o(O,we),o(we,Et),m(e,We,r),m(e,d,r),o(d,jt),o(d,be),o(be,Xt),o(d,St),o(d,xe),o(xe,At),o(d,Mt),o(d,$e),o($e,Pt),o(d,Rt),o(d,qe),o(qe,Ft),o(d,Ht),m(e,Ue,r),m(e,P,r),o(P,Dt),o(P,Te),o(Te,Lt),o(P,zt),m(e,Be,r),v(W,e,r),m(e,Ve,r),m(e,k,r),o(k,R),o(R,Ne),v(U,Ne,null),o(k,It),o(k,ye),o(ye,Ct),m(e,Ge,r),m(e,h,r),o(h,Qt),o(h,se),o(se,Wt),o(h,Ut),o(h,Oe),o(Oe,Bt),o(h,Vt),o(h,ae),o(ae,Gt),o(h,Yt),m(e,Ye,r),v(B,e,r),m(e,Je,r),m(e,E,r),o(E,F),o(F,ke),v(V,ke,null),o(E,Jt),o(E,Ee),o(Ee,Kt),m(e,Ke,r),m(e,c,r),o(c,Zt),o(c,G),o(G,eo),o(c,to),o(c,je),o(je,oo),o(c,no),o(c,Y),o(Y,so),o(c,ao),m(e,Ze,r),v(J,e,r),m(e,et,r),m(e,j,r),o(j,H),o(H,Xe),v(K,Xe,null),o(j,ro),o(j,Se),o(Se,lo),m(e,tt,r),m(e,re,r),o(re,io),m(e,ot,r),m(e,$,r),o($,Ae),o(Ae,mo),o($,po),o($,Me),o(Me,uo),o($,fo),o($,Pe),o(Pe,ho),m(e,nt,r),m(e,le,r),o(le,co),m(e,st,r),v(Z,e,r),m(e,at,r),m(e,X,r),o(X,D),o(D,Re),v(ee,Re,null),o(X,_o),o(X,Fe),o(Fe,go),m(e,rt,r),m(e,ie,r),o(ie,vo),m(e,lt,r),m(e,q,r),o(q,He),o(He,wo),o(q,bo),o(q,De),o(De,xo),o(q,$o),o(q,Le),o(Le,qo),m(e,it,r),m(e,me,r),o(me,To),m(e,mt,r),v(te,e,r),m(e,pt,r),m(e,L,r),o(L,No),o(L,ze),o(ze,yo),o(L,Oo),m(e,ut,r),v(oe,e,r),m(e,ft,r),m(e,pe,r),o(pe,ue),dt=!0},p:Tn,i(e){dt||(w(C.$$.fragment,e),w(Q.$$.fragment,e),w(W.$$.fragment,e),w(U.$$.fragment,e),w(B.$$.fragment,e),w(V.$$.fragment,e),w(J.$$.fragment,e),w(K.$$.fragment,e),w(Z.$$.fragment,e),w(ee.$$.fragment,e),w(te.$$.fragment,e),w(oe.$$.fragment,e),dt=!0)},o(e){b(C.$$.fragment,e),b(Q.$$.fragment,e),b(W.$$.fragment,e),b(U.$$.fragment,e),b(B.$$.fragment,e),b(V.$$.fragment,e),b(J.$$.fragment,e),b(K.$$.fragment,e),b(Z.$$.fragment,e),b(ee.$$.fragment,e),b(te.$$.fragment,e),b(oe.$$.fragment,e),dt=!1},d(e){t(N),e&&t(Ie),e&&t(y),x(C),e&&t(Ce),e&&t(A),e&&t(Qe),e&&t(O),x(Q),e&&t(We),e&&t(d),e&&t(Ue),e&&t(P),e&&t(Be),x(W,e),e&&t(Ve),e&&t(k),x(U),e&&t(Ge),e&&t(h),e&&t(Ye),x(B,e),e&&t(Je),e&&t(E),x(V),e&&t(Ke),e&&t(c),e&&t(Ze),x(J,e),e&&t(et),e&&t(j),x(K),e&&t(tt),e&&t(re),e&&t(ot),e&&t($),e&&t(nt),e&&t(le),e&&t(st),x(Z,e),e&&t(at),e&&t(X),x(ee),e&&t(rt),e&&t(ie),e&&t(lt),e&&t(q),e&&t(it),e&&t(me),e&&t(mt),x(te,e),e&&t(pt),e&&t(L),e&&t(ut),x(oe,e),e&&t(ft),e&&t(pe)}}}const On={local:"optimum-inference-with-onnx-runtime",sections:[{local:"switching-from-transformers-to-optimum",sections:[{local:"loading-a-vanilla-transformers-model",title:"Loading a vanilla Transformers model"},{local:"pushing-onnx-models-to-the-hugging-face-hub",title:"Pushing ONNX models to the Hugging Face Hub"}],title:"Switching from Transformers to Optimum"},{local:"export-and-inference-of-sequencetosequence-models",title:"Export and inference of sequence-to-sequence models"},{local:"export-and-inference-of-stable-diffusion-models",title:"Export and inference of Stable Diffusion models"}],title:"Optimum Inference with ONNX Runtime"};function kn(ko){return Nn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Sn extends wn{constructor(N){super();bn(this,N,kn,yn,xn,{})}}export{Sn as default,On as metadata};
